/*
 *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
 *  translate.h: 
 *
 *  Copyright (C) 2002 by Ilya Shtift. ishtift@tagil.svrw.ru
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 *  USA
 *
 *  $Id: translate.h,v 1.05 2003/03/10 04:33:42 gate Exp $
 */

#ifndef INCLUDED_translate_h
#define INCLUDED_translate_h

struct Client;

struct Codepage {
  char               name[20 + 1];
  unsigned char      to[256];
  unsigned char      from[256];

  struct Codepage    *prev;
  struct Codepage    *next;
};

extern struct Codepage *translate_codepage_add(const char *charset, const char *file);
extern struct Codepage *translate_codepage_find_byname(const char *charset);
extern struct Codepage *translate_change_codepage(struct Client *target_p, struct Codepage *cp);

#endif /* INCLUDED_translate_h */
